<template>
  <div>
    <v-text-field v-model="city" :readonly="readonly" label="miejscowość" required
      @keyup="$event => { getCities($event) }"></v-text-field>
    <ul>
      <li v-for="(city, index) in cities" :key="index" @click="() => { setCity(index) }" :class="{
        selected: index === indexCity, clicked: index === clickedIndex,
        'fade-out': index === clickedIndex
      }">
        {{ city.name }} {{ city.province }}
      </li>
    </ul>
  </div>
</template>
<script>
export default {
  name: 'AutocompleteCity',

  props: {
    default: {
      type: Object,
      required: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    }
  },

  data() {
    return {
      city: '',
      cityObject: this.default || null,
      cities: [],
      indexCity: -1,
      clickedIndex: null
    }
  },

  mounted() {
    this.$bus.$on('no-cities', () => {
      this.cities = [];
      this.indexCity = -1;
      this.clickedIndex = null;
    })
  },

  mounted() {
    if (this.cityObject) {
      this.city = this.cityObject.name + ' ' + this.cityObject.province;
    }
    this.$bus.$on('city-object', (data) => {
      this.city = data.name + ' ' + data.province;
    })
  },

  methods: {
    getCities($event) {
      if ($event.key === 'ArrowUp') {
        if (this.indexCity === 0) {
          this.indexCity = this.cities.length;
        }
        this.indexCity = (this.indexCity - 1) % this.cities.length;
        return;
      }
      if ($event.key === 'ArrowDown') {
        this.indexCity = (this.indexCity + 1) % this.cities.length;
        return;
      }
      if ($event.key === 'Enter' && this.indexCity >= 0) {
        this.setCity(this.indexCity)
        return;
      }
      if (this.city.length < 3) {
        this.cities = [];
        return;
      }
      this.$axios.post(this.$config.serverUrl + '/city', { prefix: this.city })
      .then(({ data }) => {
        this.cities = data.selected
        this.$forceUpdate()
      })
    },

    setCity(index) {
      this.cityObject = this.cities[index];
      this.city = this.cities[index].name + ' ' + this.cities[index].province;
      this.$emit('city', this.cityObject)
      setTimeout(() => {
        this.indexCity = -1;
        this.cities = [];
      }, 1000);

    }
  },
}
</script>
<style scoped lang="scss">
ul {
  position: absolute;
  z-index: 9999;
  display: flex;
  flex-direction: column;
  justify-content: left;
  width: initial;
  padding: 0px;
  background: rgba(250, 250, 250, .8);

  li {
    list-style-type: none;
    cursor: pointer;

    &.selected,
    &:hover {
      background: rgba(22, 22, 22, .7);
      color: #ffffff;
    }

    &.clicked {
      background: rgba(110, 110, 110, 1);
      color: #ffffff;
    }
  }
}</style>
